#include "DatabaseHandler/DatabaseHandler.h"
#include "DatabaseHandler/Source/v2/DataClasses/SeasonStatistics.h"
#include "DatabaseHandlerTests/InMemoryDbFixture.h"

TEST_F(InMemoryDbFixture, SeasonStatisticsTests)
{
	using namespace database_handler;
	using namespace database_handler::v2;
	using namespace database_handler::common;
	
	SeasonStatistics seasonStatistics1;
	seasonStatistics1.sm_id = 1;
	seasonStatistics1.sm_season_id = 2;
	seasonStatistics1.sm_league_id = 3;
	seasonStatistics1.number_of_clubs = 4;
	seasonStatistics1.number_of_matches = 5;
	seasonStatistics1.number_of_matches_played = 6;
	seasonStatistics1.number_of_goals = 7;
	seasonStatistics1.matches_both_teams_scored = 8;
	seasonStatistics1.number_of_yellowcards = 9;
	seasonStatistics1.number_of_yellowredcards = 10;
	seasonStatistics1.number_of_redcards = 11;
	seasonStatistics1.avg_goals_per_match_opt = 12.13;
	seasonStatistics1.avg_yellowcards_per_match_opt = 14.15;
	seasonStatistics1.avg_yellowredcards_per_match_opt = 16.17;
	seasonStatistics1.avg_redcards_per_match_opt = 18.19;
	seasonStatistics1.sm_team_with_most_goals_id_opt = 20;
	seasonStatistics1.sm_team_with_most_conceded_goals_id_opt = 21;
	seasonStatistics1.sm_team_with_most_goals_per_match_id_opt = 22;
	seasonStatistics1.sm_season_topscorer_id_opt = 23;
	seasonStatistics1.season_topscorer_number_opt = 24;
	seasonStatistics1.sm_season_assist_topscorer_id_opt = 25;
	seasonStatistics1.season_assist_topscorer_number_opt = 26;
	seasonStatistics1.sm_team_most_cleansheets_id_opt = 27;
	seasonStatistics1.team_most_cleansheets_number_opt = 28;
	seasonStatistics1.sm_goalkeeper_most_cleansheets_id_opt = 29;
	seasonStatistics1.goalkeeper_most_cleansheets_number_opt = 30;
	seasonStatistics1.goal_scored_every_minutes = 31;
	seasonStatistics1.btts_opt = 32.33;
	seasonStatistics1.avg_corners_per_match_opt = 34.35;
	seasonStatistics1.team_most_corners_count_opt = 36;
	seasonStatistics1.sm_team_most_corners_id_opt = 37;
	seasonStatistics1.win_percentage_home_opt = 38.39;
	seasonStatistics1.win_percentage_away_opt = 40.41;
	seasonStatistics1.draw_percentage_opt = 42.43;
	seasonStatistics1.avg_homegoals_per_match_opt = 44.45;
	seasonStatistics1.avg_awaygoals_per_match_opt = 46.47;
	seasonStatistics1.avg_player_rating_opt = 48.49;
	seasonStatistics1.updated_date = STR("updated_date50");
	seasonStatistics1.timezone_type = 51;
	seasonStatistics1.timezone = STR("timezone52");
	
	SeasonStatistics seasonStatistics2;
	
	SeasonStatistics seasonStatistics3;
	seasonStatistics3.sm_id = 53;
	seasonStatistics3.sm_season_id = 54;
	seasonStatistics3.sm_league_id = 55;
	seasonStatistics3.number_of_clubs = 56;
	seasonStatistics3.number_of_matches = 57;
	seasonStatistics3.number_of_matches_played = 58;
	seasonStatistics3.number_of_goals = 59;
	seasonStatistics3.matches_both_teams_scored = 60;
	seasonStatistics3.number_of_yellowcards = 61;
	seasonStatistics3.number_of_yellowredcards = 62;
	seasonStatistics3.number_of_redcards = 63;
	seasonStatistics3.avg_goals_per_match_opt = 64.65;
	seasonStatistics3.avg_yellowcards_per_match_opt = 66.67;
	seasonStatistics3.avg_yellowredcards_per_match_opt = 68.69;
	seasonStatistics3.avg_redcards_per_match_opt = 70.71;
	seasonStatistics3.sm_team_with_most_goals_id_opt = 72;
	seasonStatistics3.sm_team_with_most_conceded_goals_id_opt = 73;
	seasonStatistics3.sm_team_with_most_goals_per_match_id_opt = 74;
	seasonStatistics3.sm_season_topscorer_id_opt = 75;
	seasonStatistics3.season_topscorer_number_opt = 76;
	seasonStatistics3.sm_season_assist_topscorer_id_opt = 77;
	seasonStatistics3.season_assist_topscorer_number_opt = 78;
	seasonStatistics3.sm_team_most_cleansheets_id_opt = 79;
	seasonStatistics3.team_most_cleansheets_number_opt = 80;
	seasonStatistics3.sm_goalkeeper_most_cleansheets_id_opt = 81;
	seasonStatistics3.goalkeeper_most_cleansheets_number_opt = 82;
	seasonStatistics3.goal_scored_every_minutes = 83;
	seasonStatistics3.btts_opt = 84.85;
	seasonStatistics3.avg_corners_per_match_opt = 86.87;
	seasonStatistics3.team_most_corners_count_opt = 88;
	seasonStatistics3.sm_team_most_corners_id_opt = 89;
	seasonStatistics3.win_percentage_home_opt = 90.91;
	seasonStatistics3.win_percentage_away_opt = 92.93;
	seasonStatistics3.draw_percentage_opt = 94.95;
	seasonStatistics3.avg_homegoals_per_match_opt = 96.97;
	seasonStatistics3.avg_awaygoals_per_match_opt = 98.99;
	seasonStatistics3.avg_player_rating_opt = 100.101;
	seasonStatistics3.updated_date = STR("updated_date102");
	seasonStatistics3.timezone_type = 103;
	seasonStatistics3.timezone = STR("timezone104");
	
	std::vector<UpSeasonStatistics> oneSeasonStatistics;
	oneSeasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics1));

	std::vector<UpSeasonStatistics> twoseasonStatistics;
	twoseasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics1));
	twoseasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics2));

	std::vector<UpSeasonStatistics> threeseasonStatistics;
	threeseasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics1));
	threeseasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics2));
	threeseasonStatistics.emplace_back(std::make_unique<SeasonStatistics>(seasonStatistics3));

	EXPECT_EQ(1, oneSeasonStatistics.size());
	EXPECT_EQ(2, twoseasonStatistics.size());
	EXPECT_EQ(3, threeseasonStatistics.size());

	ASSERT_NO_THROW(db.exec(CREATE_TABLE_SEASON_STATISTICS));
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, oneSeasonStatistics));
	ASSERT_EQ(1, QueryCount<SeasonStatistics>(db));
	{
		auto seasonStatistics = QueryAll<SeasonStatistics>(db);
		EXPECT_EQ(1, seasonStatistics.size());

		EXPECT_NE(0, seasonStatistics[0]->id);
		EXPECT_EQ(seasonStatistics1.sm_id, seasonStatistics[0]->sm_id);
		EXPECT_EQ(seasonStatistics1.sm_season_id, seasonStatistics[0]->sm_season_id);
		EXPECT_EQ(seasonStatistics1.sm_league_id, seasonStatistics[0]->sm_league_id);
		EXPECT_EQ(seasonStatistics1.number_of_clubs, seasonStatistics[0]->number_of_clubs);
		EXPECT_EQ(seasonStatistics1.number_of_matches, seasonStatistics[0]->number_of_matches);
		EXPECT_EQ(seasonStatistics1.number_of_matches_played, seasonStatistics[0]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics1.number_of_goals, seasonStatistics[0]->number_of_goals);
		EXPECT_EQ(seasonStatistics1.matches_both_teams_scored, seasonStatistics[0]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics1.number_of_yellowcards, seasonStatistics[0]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics1.number_of_yellowredcards, seasonStatistics[0]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics1.number_of_redcards, seasonStatistics[0]->number_of_redcards);
		EXPECT_EQ(seasonStatistics1.avg_goals_per_match_opt, seasonStatistics[0]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowcards_per_match_opt, seasonStatistics[0]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowredcards_per_match_opt, seasonStatistics[0]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_redcards_per_match_opt, seasonStatistics[0]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_id_opt, seasonStatistics[0]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[0]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[0]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_topscorer_id_opt, seasonStatistics[0]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_topscorer_number_opt, seasonStatistics[0]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_assist_topscorer_id_opt, seasonStatistics[0]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_assist_topscorer_number_opt, seasonStatistics[0]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_cleansheets_id_opt, seasonStatistics[0]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.team_most_cleansheets_number_opt, seasonStatistics[0]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[0]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.goalkeeper_most_cleansheets_number_opt, seasonStatistics[0]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.goal_scored_every_minutes, seasonStatistics[0]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics1.btts_opt, seasonStatistics[0]->btts_opt);
		EXPECT_EQ(seasonStatistics1.avg_corners_per_match_opt, seasonStatistics[0]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics1.team_most_corners_count_opt, seasonStatistics[0]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_corners_id_opt, seasonStatistics[0]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_home_opt, seasonStatistics[0]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_away_opt, seasonStatistics[0]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics1.draw_percentage_opt, seasonStatistics[0]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics1.avg_homegoals_per_match_opt, seasonStatistics[0]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_awaygoals_per_match_opt, seasonStatistics[0]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_player_rating_opt, seasonStatistics[0]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics1.updated_date, seasonStatistics[0]->updated_date);
		EXPECT_EQ(seasonStatistics1.timezone_type, seasonStatistics[0]->timezone_type);
		EXPECT_EQ(seasonStatistics1.timezone, seasonStatistics[0]->timezone);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, twoseasonStatistics));
	ASSERT_EQ(2, QueryCount<SeasonStatistics>(db));
	{
		auto seasonStatistics = QueryAll<SeasonStatistics>(db);
		EXPECT_EQ(2, seasonStatistics.size());

		EXPECT_NE(0, seasonStatistics[0]->id);
		EXPECT_EQ(seasonStatistics1.sm_id, seasonStatistics[0]->sm_id);
		EXPECT_EQ(seasonStatistics1.sm_season_id, seasonStatistics[0]->sm_season_id);
		EXPECT_EQ(seasonStatistics1.sm_league_id, seasonStatistics[0]->sm_league_id);
		EXPECT_EQ(seasonStatistics1.number_of_clubs, seasonStatistics[0]->number_of_clubs);
		EXPECT_EQ(seasonStatistics1.number_of_matches, seasonStatistics[0]->number_of_matches);
		EXPECT_EQ(seasonStatistics1.number_of_matches_played, seasonStatistics[0]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics1.number_of_goals, seasonStatistics[0]->number_of_goals);
		EXPECT_EQ(seasonStatistics1.matches_both_teams_scored, seasonStatistics[0]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics1.number_of_yellowcards, seasonStatistics[0]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics1.number_of_yellowredcards, seasonStatistics[0]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics1.number_of_redcards, seasonStatistics[0]->number_of_redcards);
		EXPECT_EQ(seasonStatistics1.avg_goals_per_match_opt, seasonStatistics[0]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowcards_per_match_opt, seasonStatistics[0]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowredcards_per_match_opt, seasonStatistics[0]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_redcards_per_match_opt, seasonStatistics[0]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_id_opt, seasonStatistics[0]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[0]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[0]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_topscorer_id_opt, seasonStatistics[0]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_topscorer_number_opt, seasonStatistics[0]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_assist_topscorer_id_opt, seasonStatistics[0]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_assist_topscorer_number_opt, seasonStatistics[0]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_cleansheets_id_opt, seasonStatistics[0]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.team_most_cleansheets_number_opt, seasonStatistics[0]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[0]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.goalkeeper_most_cleansheets_number_opt, seasonStatistics[0]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.goal_scored_every_minutes, seasonStatistics[0]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics1.btts_opt, seasonStatistics[0]->btts_opt);
		EXPECT_EQ(seasonStatistics1.avg_corners_per_match_opt, seasonStatistics[0]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics1.team_most_corners_count_opt, seasonStatistics[0]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_corners_id_opt, seasonStatistics[0]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_home_opt, seasonStatistics[0]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_away_opt, seasonStatistics[0]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics1.draw_percentage_opt, seasonStatistics[0]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics1.avg_homegoals_per_match_opt, seasonStatistics[0]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_awaygoals_per_match_opt, seasonStatistics[0]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_player_rating_opt, seasonStatistics[0]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics1.updated_date, seasonStatistics[0]->updated_date);
		EXPECT_EQ(seasonStatistics1.timezone_type, seasonStatistics[0]->timezone_type);
		EXPECT_EQ(seasonStatistics1.timezone, seasonStatistics[0]->timezone);
		

		EXPECT_NE(0, seasonStatistics[1]->id);
		EXPECT_EQ(seasonStatistics2.sm_id, seasonStatistics[1]->sm_id);
		EXPECT_EQ(seasonStatistics2.sm_season_id, seasonStatistics[1]->sm_season_id);
		EXPECT_EQ(seasonStatistics2.sm_league_id, seasonStatistics[1]->sm_league_id);
		EXPECT_EQ(seasonStatistics2.number_of_clubs, seasonStatistics[1]->number_of_clubs);
		EXPECT_EQ(seasonStatistics2.number_of_matches, seasonStatistics[1]->number_of_matches);
		EXPECT_EQ(seasonStatistics2.number_of_matches_played, seasonStatistics[1]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics2.number_of_goals, seasonStatistics[1]->number_of_goals);
		EXPECT_EQ(seasonStatistics2.matches_both_teams_scored, seasonStatistics[1]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics2.number_of_yellowcards, seasonStatistics[1]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics2.number_of_yellowredcards, seasonStatistics[1]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics2.number_of_redcards, seasonStatistics[1]->number_of_redcards);
		EXPECT_EQ(seasonStatistics2.avg_goals_per_match_opt, seasonStatistics[1]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_yellowcards_per_match_opt, seasonStatistics[1]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_yellowredcards_per_match_opt, seasonStatistics[1]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_redcards_per_match_opt, seasonStatistics[1]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_goals_id_opt, seasonStatistics[1]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[1]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[1]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_season_topscorer_id_opt, seasonStatistics[1]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics2.season_topscorer_number_opt, seasonStatistics[1]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_season_assist_topscorer_id_opt, seasonStatistics[1]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics2.season_assist_topscorer_number_opt, seasonStatistics[1]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_most_cleansheets_id_opt, seasonStatistics[1]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics2.team_most_cleansheets_number_opt, seasonStatistics[1]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[1]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics2.goalkeeper_most_cleansheets_number_opt, seasonStatistics[1]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics2.goal_scored_every_minutes, seasonStatistics[1]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics2.btts_opt, seasonStatistics[1]->btts_opt);
		EXPECT_EQ(seasonStatistics2.avg_corners_per_match_opt, seasonStatistics[1]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics2.team_most_corners_count_opt, seasonStatistics[1]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_most_corners_id_opt, seasonStatistics[1]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics2.win_percentage_home_opt, seasonStatistics[1]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics2.win_percentage_away_opt, seasonStatistics[1]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics2.draw_percentage_opt, seasonStatistics[1]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics2.avg_homegoals_per_match_opt, seasonStatistics[1]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_awaygoals_per_match_opt, seasonStatistics[1]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_player_rating_opt, seasonStatistics[1]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics2.updated_date, seasonStatistics[1]->updated_date);
		EXPECT_EQ(seasonStatistics2.timezone_type, seasonStatistics[1]->timezone_type);
		EXPECT_EQ(seasonStatistics2.timezone, seasonStatistics[1]->timezone);
		
	}
	ASSERT_NO_THROW(InsertOr(OnConflict::Ignore, db, threeseasonStatistics));
	ASSERT_EQ(3, QueryCount<SeasonStatistics>(db));
	{
		auto seasonStatistics = QueryAll<SeasonStatistics>(db);
		EXPECT_EQ(3, seasonStatistics.size());

		EXPECT_NE(0, seasonStatistics[0]->id);
		EXPECT_EQ(seasonStatistics1.sm_id, seasonStatistics[0]->sm_id);
		EXPECT_EQ(seasonStatistics1.sm_season_id, seasonStatistics[0]->sm_season_id);
		EXPECT_EQ(seasonStatistics1.sm_league_id, seasonStatistics[0]->sm_league_id);
		EXPECT_EQ(seasonStatistics1.number_of_clubs, seasonStatistics[0]->number_of_clubs);
		EXPECT_EQ(seasonStatistics1.number_of_matches, seasonStatistics[0]->number_of_matches);
		EXPECT_EQ(seasonStatistics1.number_of_matches_played, seasonStatistics[0]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics1.number_of_goals, seasonStatistics[0]->number_of_goals);
		EXPECT_EQ(seasonStatistics1.matches_both_teams_scored, seasonStatistics[0]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics1.number_of_yellowcards, seasonStatistics[0]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics1.number_of_yellowredcards, seasonStatistics[0]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics1.number_of_redcards, seasonStatistics[0]->number_of_redcards);
		EXPECT_EQ(seasonStatistics1.avg_goals_per_match_opt, seasonStatistics[0]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowcards_per_match_opt, seasonStatistics[0]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_yellowredcards_per_match_opt, seasonStatistics[0]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_redcards_per_match_opt, seasonStatistics[0]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_id_opt, seasonStatistics[0]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[0]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[0]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_topscorer_id_opt, seasonStatistics[0]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_topscorer_number_opt, seasonStatistics[0]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_season_assist_topscorer_id_opt, seasonStatistics[0]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics1.season_assist_topscorer_number_opt, seasonStatistics[0]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_cleansheets_id_opt, seasonStatistics[0]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.team_most_cleansheets_number_opt, seasonStatistics[0]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[0]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics1.goalkeeper_most_cleansheets_number_opt, seasonStatistics[0]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics1.goal_scored_every_minutes, seasonStatistics[0]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics1.btts_opt, seasonStatistics[0]->btts_opt);
		EXPECT_EQ(seasonStatistics1.avg_corners_per_match_opt, seasonStatistics[0]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics1.team_most_corners_count_opt, seasonStatistics[0]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics1.sm_team_most_corners_id_opt, seasonStatistics[0]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_home_opt, seasonStatistics[0]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics1.win_percentage_away_opt, seasonStatistics[0]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics1.draw_percentage_opt, seasonStatistics[0]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics1.avg_homegoals_per_match_opt, seasonStatistics[0]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_awaygoals_per_match_opt, seasonStatistics[0]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics1.avg_player_rating_opt, seasonStatistics[0]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics1.updated_date, seasonStatistics[0]->updated_date);
		EXPECT_EQ(seasonStatistics1.timezone_type, seasonStatistics[0]->timezone_type);
		EXPECT_EQ(seasonStatistics1.timezone, seasonStatistics[0]->timezone);
		

		EXPECT_NE(0, seasonStatistics[1]->id);
		EXPECT_EQ(seasonStatistics2.sm_id, seasonStatistics[1]->sm_id);
		EXPECT_EQ(seasonStatistics2.sm_season_id, seasonStatistics[1]->sm_season_id);
		EXPECT_EQ(seasonStatistics2.sm_league_id, seasonStatistics[1]->sm_league_id);
		EXPECT_EQ(seasonStatistics2.number_of_clubs, seasonStatistics[1]->number_of_clubs);
		EXPECT_EQ(seasonStatistics2.number_of_matches, seasonStatistics[1]->number_of_matches);
		EXPECT_EQ(seasonStatistics2.number_of_matches_played, seasonStatistics[1]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics2.number_of_goals, seasonStatistics[1]->number_of_goals);
		EXPECT_EQ(seasonStatistics2.matches_both_teams_scored, seasonStatistics[1]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics2.number_of_yellowcards, seasonStatistics[1]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics2.number_of_yellowredcards, seasonStatistics[1]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics2.number_of_redcards, seasonStatistics[1]->number_of_redcards);
		EXPECT_EQ(seasonStatistics2.avg_goals_per_match_opt, seasonStatistics[1]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_yellowcards_per_match_opt, seasonStatistics[1]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_yellowredcards_per_match_opt, seasonStatistics[1]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_redcards_per_match_opt, seasonStatistics[1]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_goals_id_opt, seasonStatistics[1]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[1]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[1]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics2.sm_season_topscorer_id_opt, seasonStatistics[1]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics2.season_topscorer_number_opt, seasonStatistics[1]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_season_assist_topscorer_id_opt, seasonStatistics[1]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics2.season_assist_topscorer_number_opt, seasonStatistics[1]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_most_cleansheets_id_opt, seasonStatistics[1]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics2.team_most_cleansheets_number_opt, seasonStatistics[1]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics2.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[1]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics2.goalkeeper_most_cleansheets_number_opt, seasonStatistics[1]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics2.goal_scored_every_minutes, seasonStatistics[1]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics2.btts_opt, seasonStatistics[1]->btts_opt);
		EXPECT_EQ(seasonStatistics2.avg_corners_per_match_opt, seasonStatistics[1]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics2.team_most_corners_count_opt, seasonStatistics[1]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics2.sm_team_most_corners_id_opt, seasonStatistics[1]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics2.win_percentage_home_opt, seasonStatistics[1]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics2.win_percentage_away_opt, seasonStatistics[1]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics2.draw_percentage_opt, seasonStatistics[1]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics2.avg_homegoals_per_match_opt, seasonStatistics[1]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_awaygoals_per_match_opt, seasonStatistics[1]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics2.avg_player_rating_opt, seasonStatistics[1]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics2.updated_date, seasonStatistics[1]->updated_date);
		EXPECT_EQ(seasonStatistics2.timezone_type, seasonStatistics[1]->timezone_type);
		EXPECT_EQ(seasonStatistics2.timezone, seasonStatistics[1]->timezone);
		

		EXPECT_NE(0, seasonStatistics[2]->id);
		EXPECT_EQ(seasonStatistics3.sm_id, seasonStatistics[2]->sm_id);
		EXPECT_EQ(seasonStatistics3.sm_season_id, seasonStatistics[2]->sm_season_id);
		EXPECT_EQ(seasonStatistics3.sm_league_id, seasonStatistics[2]->sm_league_id);
		EXPECT_EQ(seasonStatistics3.number_of_clubs, seasonStatistics[2]->number_of_clubs);
		EXPECT_EQ(seasonStatistics3.number_of_matches, seasonStatistics[2]->number_of_matches);
		EXPECT_EQ(seasonStatistics3.number_of_matches_played, seasonStatistics[2]->number_of_matches_played);
		EXPECT_EQ(seasonStatistics3.number_of_goals, seasonStatistics[2]->number_of_goals);
		EXPECT_EQ(seasonStatistics3.matches_both_teams_scored, seasonStatistics[2]->matches_both_teams_scored);
		EXPECT_EQ(seasonStatistics3.number_of_yellowcards, seasonStatistics[2]->number_of_yellowcards);
		EXPECT_EQ(seasonStatistics3.number_of_yellowredcards, seasonStatistics[2]->number_of_yellowredcards);
		EXPECT_EQ(seasonStatistics3.number_of_redcards, seasonStatistics[2]->number_of_redcards);
		EXPECT_EQ(seasonStatistics3.avg_goals_per_match_opt, seasonStatistics[2]->avg_goals_per_match_opt);
		EXPECT_EQ(seasonStatistics3.avg_yellowcards_per_match_opt, seasonStatistics[2]->avg_yellowcards_per_match_opt);
		EXPECT_EQ(seasonStatistics3.avg_yellowredcards_per_match_opt, seasonStatistics[2]->avg_yellowredcards_per_match_opt);
		EXPECT_EQ(seasonStatistics3.avg_redcards_per_match_opt, seasonStatistics[2]->avg_redcards_per_match_opt);
		EXPECT_EQ(seasonStatistics3.sm_team_with_most_goals_id_opt, seasonStatistics[2]->sm_team_with_most_goals_id_opt);
		EXPECT_EQ(seasonStatistics3.sm_team_with_most_conceded_goals_id_opt, seasonStatistics[2]->sm_team_with_most_conceded_goals_id_opt);
		EXPECT_EQ(seasonStatistics3.sm_team_with_most_goals_per_match_id_opt, seasonStatistics[2]->sm_team_with_most_goals_per_match_id_opt);
		EXPECT_EQ(seasonStatistics3.sm_season_topscorer_id_opt, seasonStatistics[2]->sm_season_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics3.season_topscorer_number_opt, seasonStatistics[2]->season_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics3.sm_season_assist_topscorer_id_opt, seasonStatistics[2]->sm_season_assist_topscorer_id_opt);
		EXPECT_EQ(seasonStatistics3.season_assist_topscorer_number_opt, seasonStatistics[2]->season_assist_topscorer_number_opt);
		EXPECT_EQ(seasonStatistics3.sm_team_most_cleansheets_id_opt, seasonStatistics[2]->sm_team_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics3.team_most_cleansheets_number_opt, seasonStatistics[2]->team_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics3.sm_goalkeeper_most_cleansheets_id_opt, seasonStatistics[2]->sm_goalkeeper_most_cleansheets_id_opt);
		EXPECT_EQ(seasonStatistics3.goalkeeper_most_cleansheets_number_opt, seasonStatistics[2]->goalkeeper_most_cleansheets_number_opt);
		EXPECT_EQ(seasonStatistics3.goal_scored_every_minutes, seasonStatistics[2]->goal_scored_every_minutes);
		EXPECT_EQ(seasonStatistics3.btts_opt, seasonStatistics[2]->btts_opt);
		EXPECT_EQ(seasonStatistics3.avg_corners_per_match_opt, seasonStatistics[2]->avg_corners_per_match_opt);
		EXPECT_EQ(seasonStatistics3.team_most_corners_count_opt, seasonStatistics[2]->team_most_corners_count_opt);
		EXPECT_EQ(seasonStatistics3.sm_team_most_corners_id_opt, seasonStatistics[2]->sm_team_most_corners_id_opt);
		EXPECT_EQ(seasonStatistics3.win_percentage_home_opt, seasonStatistics[2]->win_percentage_home_opt);
		EXPECT_EQ(seasonStatistics3.win_percentage_away_opt, seasonStatistics[2]->win_percentage_away_opt);
		EXPECT_EQ(seasonStatistics3.draw_percentage_opt, seasonStatistics[2]->draw_percentage_opt);
		EXPECT_EQ(seasonStatistics3.avg_homegoals_per_match_opt, seasonStatistics[2]->avg_homegoals_per_match_opt);
		EXPECT_EQ(seasonStatistics3.avg_awaygoals_per_match_opt, seasonStatistics[2]->avg_awaygoals_per_match_opt);
		EXPECT_EQ(seasonStatistics3.avg_player_rating_opt, seasonStatistics[2]->avg_player_rating_opt);
		EXPECT_EQ(seasonStatistics3.updated_date, seasonStatistics[2]->updated_date);
		EXPECT_EQ(seasonStatistics3.timezone_type, seasonStatistics[2]->timezone_type);
		EXPECT_EQ(seasonStatistics3.timezone, seasonStatistics[2]->timezone);
		
	}
}